git-branch.sh 2.3 KB
Newer Older
L
Linus Torvalds 已提交
1 2
#!/bin/sh

J
Junio C Hamano 已提交
3
. git-sh-setup || die "Not a git archive"
L
Linus Torvalds 已提交
4

5
usage () {
6
    echo >&2 "usage: $(basename $0)"' [-d <branch>] | [[-f] <branch> [start-point]]
7 8 9 10 11 12 13 14

If no arguments, show available branches and mark current branch with a star.
If one argument, create a new branch <branchname> based off of current HEAD.
If two arguments, create a new branch <branchname> based off of <start-point>.
'
    exit 1
}

15 16 17
headref=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD |
	sed -e 's|^refs/heads/||')

18
delete_branch () {
19 20 21 22 23 24 25 26 27 28 29 30 31 32 33
    option="$1"
    shift
    for branch_name
    do
	case ",$headref," in
	",$branch_name,")
	    die "Cannot delete the branch you are on." ;;
	,,)
	    die "What branch are you on anyway?" ;;
	esac
	branch=$(cat "$GIT_DIR/refs/heads/$branch_name") &&
	    branch=$(git-rev-parse --verify "$branch^0") ||
		die "Seriously, what branch are you talking about?"
	case "$option" in
	-D)
34 35
	    ;;
	*)
36 37 38 39 40 41 42 43 44 45 46 47
	    mbs=$(git-merge-base -a "$branch" HEAD | tr '\012' ' ')
	    case " $mbs " in
	    *' '$branch' '*)
		# the merge base of branch and HEAD contains branch --
		# which means that the HEAD contains everything in the HEAD.
		;;
	    *)
		echo >&2 "The branch '$branch_name' is not a strict subset of your current HEAD.
    If you are sure you want to delete it, run 'git branch -D $branch_name'."
		exit 1
		;;
	    esac
48 49
	    ;;
	esac
50 51 52
	rm -f "$GIT_DIR/refs/heads/$branch_name"
	echo "Deleted branch $branch_name."
    done
53 54 55
    exit 0
}

56
force=
57 58 59 60
while case "$#,$1" in 0,*) break ;; *,-*) ;; *) break ;; esac
do
	case "$1" in
	-d | -D)
61
		delete_branch "$@"
62 63
		exit
		;;
64 65 66
	-f)
		force="$1"
		;;
67 68 69 70 71 72 73 74 75 76 77
	--)
		shift
		break
		;;
	-*)
		usage
		;;
	esac
	shift
done

78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94
case "$#" in
0)
	git-rev-parse --symbolic --all |
	sed -ne 's|^refs/heads/||p' |
	sort |
	while read ref
	do
		if test "$headref" = "$ref"
		then
			pfx='*'
		else
			pfx=' '
		fi
		echo "$pfx $ref"
	done
	exit 0 ;;
1)
95
	head=HEAD ;;
96
2)
97 98
	head="$2^0" ;;
esac
99
branchname="$1"
100

J
Junio C Hamano 已提交
101
rev=$(git-rev-parse --verify "$head") || exit
L
Linus Torvalds 已提交
102

103 104
git-check-ref-format "heads/$branchname" ||
	die "we do not like '$branchname' as a branch name."
L
Linus Torvalds 已提交
105

106 107 108 109 110 111 112 113 114 115
if [ -e "$GIT_DIR/refs/heads/$branchname" ]
then
	if test '' = "$force"
	then
		die "$branchname already exists."
	elif test "$branchname" = "$headref"
	then
		die "cannot force-update the current branch."
	fi
fi
116 117
git update-ref "refs/heads/$branchname" $rev